// Generated by CoffeeScript 1.9.3
(function() {
  var React, _, invariant, mousetrap, shortcuts;

  React = require('react');

  _ = require('lodash');

  invariant = require('invariant');

  mousetrap = require('mousetrap');

  shortcuts = React.createFactory('shortcuts');

  module.exports = React.createClass({
    displayName: 'Shortcuts',
    contextTypes: {
      shortcuts: React.PropTypes.object.isRequired
    },
    propTypes: {
      handler: React.PropTypes.func.isRequired,
      name: React.PropTypes.string.isRequired,
      element: React.PropTypes.func,
      tabIndex: React.PropTypes.number,
      className: React.PropTypes.string,
      eventType: React.PropTypes.string,
      stopPropagation: React.PropTypes.bool,
      preventDefault: React.PropTypes.bool,
      targetNode: React.PropTypes.object,
      nativeKeyBindingsClassName: React.PropTypes.string
    },
    getDefaultProps: function() {
      return {
        element: null,
        tabIndex: null,
        className: null,
        eventType: null,
        stopPropagation: null,
        preventDefault: true,
        targetNode: null,
        nativeKeyBindingsClassName: 'native-key-bindings'
      };
    },
    _bindShortcuts: function(shortcutsArr) {
      var element;
      if (this.props.targetNode) {
        element = this.props.targetNode;
        invariant(element, 'TargetNode was not found.');
        element.setAttribute('tabindex', this.props.tabIndex || -1);
      } else {
        element = React.findDOMNode(this.refs.shortcuts);
      }
      this._monkeyPatchMousetrap();
      return mousetrap(element).bind(shortcutsArr, this._handleShortcuts, this.props.eventType);
    },
    _monkeyPatchMousetrap: function() {
      return mousetrap.prototype.stopCallback = (function(_this) {
        return function(e, element) {
          var result;
          result = _.includes(element.className, _this.props.nativeKeyBindingsClassName);
          return result;
        };
      })(this);
    },
    _unbindShortcuts: function(shortcutsArr) {
      var element;
      if (this.props.targetNode) {
        this.props.targetNode.removeAttribute('tabindex');
      } else {
        element = React.findDOMNode(this.refs.shortcuts);
      }
      return mousetrap(element).unbind(shortcutsArr);
    },
    _onUpdate: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this._bindShortcuts(shortcutsArr);
    },
    componentDidMount: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._bindShortcuts(shortcutsArr);
      return this.context.shortcuts.addUpdateListener(this._onUpdate);
    },
    componentWillUnmount: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this.context.shortcuts.removeUpdateListener(this._onUpdate);
    },
    _handleShortcuts: function(e, keyName) {
      var shortcutName;
      if (this.props.preventDefault) {
        e.preventDefault();
      }
      if (this.props.stopPropagation) {
        e.stopPropagation();
      }
      shortcutName = this.context.shortcuts.findShortcutName(keyName, this.props.name);
      return this.props.handler(shortcutName);
    },
    render: function() {
      var element;
      element = shortcuts;
      if (_.isFunction(this.props.element)) {
        element = this.props.element;
      }
      return element({
        tabIndex: this.props.tabIndex || -1,
        className: this.props.className,
        ref: 'shortcuts'
      }, this.props.children);
    }
  });

}).call(this);
